# Solid Forms of Water by Geoscapers

A demo by Geoscapers for Instanssi 2024 
by Shiera, fractalPixel, and fergusq

Music by fergusq.

Implemented using signed (distance) fields and raymarching,
in GLSL and typescript.


## Running the demo

The demo is in the self-contained webpage in dist/
Simply open it with a browser and press the start button.
(Opening it directly in github doesn't work as github will just show the source code of the page).


## Setup development environment

First install nvm (node version manager https://github.com/nvm-sh/nvm ).

The use the correct version of NPM with:

    nvm install 16"

or if it's already installed:

    nvm use 16

Then install necessary libraries by running setup.sh or run

    npm install


Visual studio code is one possible development environment.
For working with glsl shaders, the WebGL GLSL Editor -extension is pretty good.
Typescript support is builtin.


## Development

dev.sh opens a browser tab and serves the demo in it, updating it when the code changes.

build.sh builds a release version and puts it in the dist/ folder.


## Build tools used 

The parcel framework/tool is used to package all code, shaders, and the website into a single webpage.

(It's called by the dev and build scripts)


## Sound
Guitar-like sounds are generated with the Karplus-Strong algorithm, see references e.g.:
- http://amid.fish/karplus-strong
- https://flothesof.github.io/Karplus-Strong-algorithm-Python.html
- http://amid.fish/javascript-karplus-strong
- http://ringbuffer.org/sound_synthesis_introduction/Physical_Modeling/physical-modeling-karplus-strong-algorithm/


## Shaders

Raymarching of signed distance fields is used to render the graphics, see e.g. https://iquilezles.org/articles/raymarchingdf/

When designing performat signed distance fields, a key requirement is to add various bounding volume checks, to avoid calculating the distance to all shapes in the whole scene for each step on a ray for each pixel.  