
/**
 * A very basic 3d vector.
 */
export default class Vec3 {
    constructor(
        public x: number = 0,
        public y: number = 0,
        public z: number = 0
    ) {}

    set(x: number, y: number, z: number) {
        this.x = x
        this.y = y
        this.z = z
    }

    setToVec(other: Vec3) {
        this.x = other.x
        this.y = other.y
        this.z = other.z
    }

    addScaled(other: Vec3, scale: number) {
        this.x += other.x * scale
        this.y += other.y * scale
        this.z += other.z * scale
    }    

    add(other: Vec3) {
        this.x += other.x
        this.y += other.y
        this.z += other.z
    }    

    sub(other: Vec3) {
        this.x -= other.x
        this.y -= other.y
        this.z -= other.z
    }    

    length(): number {
        return Math.sqrt(this.x*this.x + this.y*this.y + this.z*this.z)
    }

    normalize() {
        const len = this.length()

        if (len <= 0) {
            this.x = 0
            this.y = 1
            this.z = 0
        }
        else {
            this.x /= len
            this.y /= len
            this.z /= len
        }
    }        

    mul(scalar: number) {
        this.x *= scalar
        this.y *= scalar
        this.z *= scalar
    }
}